<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class DbDriver_mysqli extends BaseClass implements DriverDB
{
	public
		$link_id=-1,
		$db;
	protected
		$Base,
		$query_id=-1,
		$open_queries=array();

	public function __construct(&$Base)
	{
		$this->Base=$Base;
	}

	public function Connect(array $params)
	{
		if (is_resource($this->link_id))
			return true;
		if(!isset($params['host']) or !isset($params['user']) or !isset($params['pass']) or !isset($params['db']))
			return false;
		$id=mysqli_connect($params['host'],$params['user'],$params['pass'],$params['db']);
		if($id===false)
			return false;
		$this->db=$params['db'];
		$this->link_id=$id;
		if(!$this->SelectDb(''))
		{
			$this->link_id=-1;
			$this->Base->Error('select_db');
			return false;
		}
		mysqli_autocommit($id,true);
		mysqli_query($id,'SET NAMES '.ELEANOR_DBCHARSET);
		#Если проблема с кодировкой - раскоментируйте строки (по одной)
		#mysqli_query($id,'SET CHARACTER SET '.ELEANOR_DBCHARSET);
		#mysqli_query($id,'SET character_set_client=\''.ELEANOR_DBCHARSET.'\'');
		#mysqli_query($id,'SET character_set_results=\''.ELEANOR_DBCHARSET.'\'');
		#mysqli_query($id,'SET collation_connection=\''.ELEANOR_DBCHARSET.'_general_ci\'');
		return true;
	}

	public function SelectDb($name='')
	{
		return mysqli_select_db($this->link_id,$name!='' ? $name : $this->db);
	}

	public function Close()
	{
		if ($this->link_id===-1)
			return true;
		foreach ($this->open_queries as &$v)
			$this->Free($v);
		$this->open_queries=array();
		$this->current_query='';
		$res=mysqli_close($this->link_id);
		$this->query_id=$this->link_id=-1;
		return $res;
	}

	public function Free($qid)
	{
		if ($qid===-1)
			$qid=$this->query_id;
		if (!is_resource($qid))
			return true;
		return mysqli_free_result($qid);
	}

	public function Version()
	{
		return str_replace('-nt-max','',mysqli_get_server_info($this->link_id));
	}

	public function Escape($str)
	{
		return mysqli_real_escape_string($this->link_id,$str);
	}

	public function Query($query)
	{
		$this->query_id=mysqli_query($this->link_id,$query);
		if(strpos($query,'SELECT')===0 and $this->query_id!==false)
			$this->open_queries[]=$this->query_id;
		return $this->query_id;
	}

	public function Error()
	{
		return $this->link_id==-1 ? mysqli_connect_error() : mysqli_error($this->link_id);
	}

	public function ErrorNo()
	{
		return $this->link_id==-1 ? mysqli_connect_errno() : mysqli_errno($this->link_id);
	}

	public function Transaction($event)
	{
		switch ($event)
		{
			case 'BEGIN':
				return mysqli_autocommit($this->link_id,false);
			break;

			case 'COMMIT':
				$result=mysqli_commit($this->link_id);
				mysqli_autocommit($this->link_id,true);
				return $result;
			break;

			case 'ROLLBACK':
				$result=mysqli_rollback($this->link_id);
				mysqli_autocommit($this->link_id,true);
				return $result;
			break;
		}
		return false;
	}

	public function AffectedRows()
	{
		return mysqli_affected_rows($this->link_id);
	}

	public function FetchRow($qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		return mysqli_fetch_row($qid);
	}

	public function FetchAssoc($qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		return mysqli_fetch_assoc($qid);
	}

	public function FetchArray($qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		return mysqli_fetch_array($qid);
	}

	public function FetchObject($qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		return mysqli_fetch_object($qid);
	}

	public function NumRows($qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		return mysqli_num_rows($qid);
	}

	public function NumFields($qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		return mysqli_num_fields($qid);
	}

	public function RowSeek($int,$qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		return mysqli_data_seek($qid,$int);
	}

	public function InsertId()
	{
		return mysqli_insert_id($this->link_id);
	}
}
?>